--Led component, top leve by Hongsen Yu.
--Build it in SOPC as top

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity de2_led_controller is
	port (
		clk : in std_logic;
		reset_n : in std_logic;
		read : in std_logic;
		write : in std_logic;
		chipselect : in std_logic;
		address : in std_logic_vector(4 downto 0);
		readdata : out std_logic_vector(15 downto 0);
		writedata : in std_logic_vector(15 downto 0);
		HEX0, HEX1, HEX2, HEX3 : out std_logic_vector(6 downto 0)
	);
end de2_led_controller;

architecture rtl of de2_led_controller is
type ram_type is array(3 downto 0) of std_logic_vector(15 downto 0);
signal RAM : ram_type;
signal ram_address : unsigned(3 downto 0);

component decoder
port(
	sel:in integer;
	res:out std_logic_vector(6 downto 0)
);
end component;

begin
	ram_address <= unsigned(address(3 downto 0));
	Digital0: decoder port map(CONV_INTEGER(RAM(0)), HEX0);
	Digital1: decoder port map(CONV_INTEGER(RAM(1)), HEX1);
	Digital2: decoder port map(CONV_INTEGER(RAM(2)), HEX2);
	Digital3: decoder port map(CONV_INTEGER(RAM(3)), HEX3);
process (clk)
begin
	if rising_edge(clk) then
		if reset_n = '0' then
--			HEX0 <= (others => '0');
--			HEX1 <= (others => '0');
--			HEX2 <= (others => '0');
--			HEX3 <= (others => '0');
		else
			if chipselect = '1' then
					if read = '1' then
						readdata <= RAM(CONV_INTEGER(ram_address));
					elsif write = '1' then
						RAM(CONV_INTEGER(ram_address)) <= writedata;
					end if;
			end if;
		end if;
	end if;
end process;
end rtl;
